Bug 276872 - New tab should be placed right after current tab, not at the end.
Summary: New tab should be placed right after current tab, not at the end.
Status: RESOLVED FIXED
Alias: None
Product: konsole
Classification: Applications
Component: general (show other bugs)
Version: 2.7.999
Platform: Archlinux Linux
: NOR wishlist (vote)
Target Milestone: ---
Assignee: Konsole Developer
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2011-07-01 07:51 UTC by Jekyll Wu
Modified: 2011-09-27 21:15 UTC (History)
1 user (show)

See Also:
Latest Commit:
Version Fixed In: 4.8


Attachments
put the new tab right after current tab (983 bytes, patch)
2011-07-01 07:51 UTC, Jekyll Wu
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Jekyll Wu 2011-07-01 07:51:45 UTC
Created attachment 61521 [details]
put the new tab right after current tab

Version:           2.7.999 (using KDE 4.6.4) 
OS:                Linux

Konsole provides the option of 'start in same directory as current tab'. This
is nice, but konsole always put new tab at the end of tab list, which make this
nice option not as useful as it appears.

For example, I have 5 tabs open. In tab #2 I am compiling some code and I
suddenly have a nice idea and want to grep something, So I open a new tab.
The 'grep' tab start at the same directory as the 'compilation' tab , but is
placed at the end(#6). After I finish greping and want to switch back to the
'compilation' tab(#2), I have 3 choices:

  a). Use mouse to click tab #2, which is slow compared with keyboard.
  b). Press 'Shift+Left' 4 times
  c). Press 'Ctr+Shift+Alt' 3 times to move the 'grep' tab to place #3, then
      press 'Shift+left'

Has the 'grep' tab been placed right after the 'compilation' tab, at #3, I
would only need to press 'Shift+left' one time to switch the focus .

So this example shows that placing new tab right after current tab can make
(some) users' life much easier. And I think that's the natural result following
the 'start in same directory' option: users expect tabs doing related work to be
placed near each other.

The attached patch is a quick hack. It always puts new tab right after current
tab, regardless of whether 'start in same directory' is enabled or not. 


Reproducible: Always

Steps to Reproduce:
1. open 5 tabs in konsole
2. change their title to #1,#2,#3,#4,#5
3. switch focus to #2
4. open a new tab


Actual Results:  
the new tab is placed after #5

Expected Results:  
the new tab is placed after #2
Comment 1 Kurt Hindenburg 2011-07-31 02:38:47 UTC
Git commit 676df0c26e5c01652da64690756b74fbe180a080 by Kurt Hindenburg.
Committed on 31/07/2011 at 04:17.
Pushed by hindenburg into branch 'master'.

New tabs will be placed to the right of the current tab.

Currently new tabs are placed at the end which is not very convenient.

Patch by Jekyll Wu <adaptee@gmail.com>
FEATURE: 276872
FIXED-IN: 4.8

M  +11   -1    src/ViewManager.cpp

http://commits.kde.org/konsole/676df0c26e5c01652da64690756b74fbe180a080
Comment 2 Ivo Anjo 2011-08-13 15:06:20 UTC
Can this at least be configurable?
All KDE applications I've tried do not do this (dolphin, konqueror, kate, k3b, ktorrent), nor does gnome-terminal.
Firefox does it, but offers an option to disable (which I use).

Please consider that this is quite a big change, and lots of users (like me) have used the old behavior for years.

Thanks.
Comment 3 Jekyll Wu 2011-08-15 04:05:27 UTC
(In reply to comment #2)
> Can this at least be configurable? 

I will try to make it configurable before it is shipped in 4.8.
Comment 4 Jekyll Wu 2011-09-26 22:46:57 UTC
Git commit acd37f7a739ffac0863b2580c775b0956c45baa8 by Jekyll Wu.
Committed on 27/09/2011 at 00:43.
Pushed by jekyllwu into branch 'master'.

Allow users to control where the newly created tab should be placed.

CCBUG:276872
REVIEW:102685

M  +13   -1    src/EditProfileDialog.cpp
M  +1    -0    src/EditProfileDialog.h
M  +21   -1    src/EditProfileDialog.ui
M  +2    -0    src/Profile.cpp
M  +13   -0    src/Profile.h
M  +15   -6    src/ViewManager.cpp

http://commits.kde.org/konsole/acd37f7a739ffac0863b2580c775b0956c45baa8
Comment 5 Ivo Anjo 2011-09-27 21:15:13 UTC
Thanks a lot for looking into this! Cheers :)